## ros-humble-rsl 0.2.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.22)
project(rsl VERSION 0.2.1 LANGUAGES CXX DESCRIPTION "ROS Support Library")

set(CMAKE_CXX_EXTENSIONS OFF)

find_package(ament_cmake_ros REQUIRED)
find_package(Eigen3 REQUIRED)
find_package(fmt REQUIRED)
find_package(rclcpp REQUIRED)
find_package(tcb_span REQUIRED)
find_package(tl_expected REQUIRED)

if(CMAKE_CXX_COMPILER_ID MATCHES "(GNU|Clang)")
    add_compile_options(-Werror -Wall -Wextra -Wpedantic -Wshadow -Wconversion -Wsign-conversion -Wold-style-cast)
endif()

add_library(rsl
    src/parameter_validators.cpp
    src/random.cpp
)
add_library(rsl::rsl ALIAS rsl)
target_compile_features(rsl PUBLIC cxx_std_17)
target_include_directories(rsl PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include/rsl>
)
target_link_libraries(rsl PUBLIC
    Eigen3::Eigen
    fmt::fmt
    rclcpp::rclcpp
    tcb_span::tcb_span
    tl_expected::tl_expected
)

add_subdirectory(docs)

if(BUILD_TESTING)
    add_subdirectory(tests)
endif()

install(
    DIRECTORY include/
    DESTINATION include/rsl
)
install(
    TARGETS rsl
    EXPORT export_rsl
    ARCHIVE DESTINATION lib
    LIBRARY DESTINATION lib
    RUNTIME DESTINATION bin
    INCLUDES DESTINATION include
)

ament_export_targets(export_rsl HAS_LIBRARY_TARGET)
ament_export_dependencies(
    Eigen3
    fmt
    rclcpp
    tcb_span
    tl_expected
)
ament_package()

add_custom_target(tidy COMMAND run-clang-tidy -p ${CMAKE_BINARY_DIR})

=== docs/CMakeLists.txt ===
find_package(Doxygen 1.8 REQUIRED COMPONENTS doxygen)

file(DOWNLOAD
     https://raw.githubusercontent.com/jothepro/doxygen-awesome-css/v2.1.0/doxygen-awesome.css
     ${CMAKE_CURRENT_BINARY_DIR}/doxygen-awesome.css)

set(DOXYGEN_DISABLE_INDEX NO)
set(DOXYGEN_FULL_SIDEBAR NO)
set(DOXYGEN_GENERATE_TREEVIEW YES)
set(DOXYGEN_HTML_EXTRA_STYLESHEET ${CMAKE_CURRENT_BINARY_DIR}/doxygen-awesome.css)
set(DOXYGEN_STRIP_FROM_PATH ${PROJECT_SOURCE_DIR}/include)
set(DOXYGEN_WARN_AS_ERROR YES)
set(DOXYGEN_WARN_IF_UNDOCUMENTED NO)
doxygen_add_docs(docs ${PROJECT_SOURCE_DIR}/include)

=== tests/CMakeLists.txt ===
list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

find_package(Catch2 3.3.0 REQUIRED)
find_package(range-v3 REQUIRED)

add_executable(test-rsl
    algorithm.cpp
    monad.cpp
    no_discard.cpp
    overload.cpp
    parameter_validators.cpp
    queue.cpp
    random.cpp
    static_string.cpp
    static_vector.cpp
    try.cpp)
target_link_libraries(test-rsl PRIVATE
    rsl::rsl
    Catch2::Catch2WithMain
    range-v3::range-v3
)
catch_discover_tests(test-rsl)

=== debian/changelog ===
ros-humble-rsl (0.2.2-1jammy) jammy; urgency=high

  * Deprecate rsl::lower_bounds and rsl::upper_bounds
  * Depend on ament_cmake_ros for SHARED default
  * Upgrade with new pkgs to fix issue with ROS
  * Update Catch2
  * Contributors: Chris Thrasher, Tyler Weaver

 -- Tyler Weaver <maybe@tylerjw.dev>  Thu, 23 Mar 2023 06:00:00 -0000

ros-humble-rsl (0.2.1-1jammy) jammy; urgency=high

  * Use constructors over factory functions when possible
  * Implement rsl::rng with std::optional
  * Fix bug when trying to seed rng from first call
  * Make rsl::rng() tests more strenuous
    Seeding on the first call tests a code path that hadn't yet been
    tested but is a valid use of the API.
  * Change version of range-v3 to allow building on Ubuntu Focal (#73 <https://github.com/PickNikRobotics/RSL/issues/73>)
  * Add missing header
    Fixes a build issue when using GCC 12
  * Make it easy for users to override
  * Update Catch2
  * Add tests for rsl::to_parameter_result_msg
  * Contributors: Chris Thrasher, Tony Najjar, Tyler Weaver

 -- Tyler Weaver <maybe@tylerjw.dev>  Tue, 29 Nov 2022 07:00:00 -0000

ros-humble-rsl (0.2.0-1jammy) jammy; urgency=high

  * New features
    * rclcpp::Parameter validator functions
    * Algorithms from parameter_traits
    * rsl::StaticVector and rsl::StaticString
  * Doxygen site: https://picknikrobotics.github.io/RSL/files.html
    * Link to the docs from the README
    * Use doxygen-awesome documentation style
    * Deploy documentation website from CI
    * Add Doxygen comments for rsl::Overload
    * Add Doxygen comments for TRY
  * Cleanups
    * Prevent unnecessary string copy
    * Ensure global constants do not violate the ODR
    * Hide rsl::NoDiscard implementation details
    * Use more [[nodiscard]]
    * Fix to_vector for vector<bool>
    * Ensure static container iterators are used
    * Default to building a shared library
    * Use generator-agnostic CMake commands
    * Remove C compiler settings
    * Don't require compiler extensions
    * Use more expressive path variable
    * Add clang-tidy integration and fix errors
    * Address clang-tidy findings
    * Update FindCatch2 module
    * Update Catch2
  * Contributors: Chris Thrasher, Tyler Weaver

 -- Tyler Weaver <maybe@tylerjw.dev>  Tue, 15 Nov 2022 07:00:00 -0000

ros-humble-rsl (0.1.1-1jammy) jammy; urgency=high

  * Fix CMake configuration warnings
  * Contributors: Chris Thrasher

 -- Tyler Weaver <maybe@tylerjw.dev>  Tue, 04 Oct 2022 06:00:00 -0000

ros-humble-rsl (0.1.0-1jammy) jammy; urgency=high

  * monad.hpp - Functions and operators for monadic expressions
  * no_discard.hpp - [[nodiscard]] for lambdas
  * overload.hpp - Class template for easily visiting variants
  * queue.hpp - Thread-safe queue
  * random.hpp - Modern C++ randomness made easy
  * try.hpp - Macro to emulatate absl::CONFIRM or operator? from Rust
  * Contributors: Chris Thrasher, Tyler Weaver

 -- Tyler Weaver <maybe@tylerjw.dev>  Tue, 04 Oct 2022 06:00:00 -0000

=== debian/control ===
Source: ros-humble-rsl
Section: misc
Priority: optional
Maintainer: Tyler Weaver <maybe@tylerjw.dev>
Build-Depends: debhelper (>= 9.0.0), clang-tidy <!nocheck>, doxygen, git, libeigen3-dev, libfmt-dev, librange-v3-dev <!nocheck>, ros-humble-ament-cmake-ros, ros-humble-rclcpp, ros-humble-tcb-span, ros-humble-tl-expected, ros-humble-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-humble-rsl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libeigen3-dev, libfmt-dev, ros-humble-rclcpp, ros-humble-tcb-span, ros-humble-tl-expected, ros-humble-ros-workspace
Description: ROS Support Library

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/humble/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/humble" \
		-DAMENT_PREFIX_PATH="/opt/ros/humble" \
		-DCMAKE_PREFIX_PATH="/opt/ros/humble" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-rsl//opt/ros/humble/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_install

## ros-humble-rsl 1.1.0

=== debian/changelog ===
ros-humble-rsl (1.1.0-1bookworm) bookworm; urgency=high

  * Fix ament_target_dependencies integration
  * Add rsl::maybe_error
  * Disable tests by default
  * Stop using non-standard M_PI
  * Contributors: Chris Thrasher

 -- Tyler Weaver <maybe@tylerjw.dev>  Tue, 19 Dec 2023 16:00:00 -0000

ros-humble-rsl (1.0.1-1bookworm) bookworm; urgency=high

  * Add more messages for assertion failures
  * Document API changes from v0 to v1
  * Contributors: Chris Thrasher

 -- Tyler Weaver <maybe@tylerjw.dev>  Tue, 05 Dec 2023 16:00:00 -0000

ros-humble-rsl (1.0.0-1bookworm) bookworm; urgency=high

  * Add rsl::StrongType
  * Quote values in error messages
  * Make doxygen a weak dependency
  * Mark git as a test dependency
  * Contributors: Andrew, Chris Thrasher, Michael Carroll, Tyler Weaver, andrea

 -- Tyler Weaver <maybe@tylerjw.dev>  Sun, 03 Dec 2023 16:00:00 -0000

ros-humble-rsl (0.2.2-1bookworm) bookworm; urgency=high

  * Deprecate rsl::lower_bounds and rsl::upper_bounds
  * Depend on ament_cmake_ros for SHARED default
  * Upgrade with new pkgs to fix issue with ROS
  * Update Catch2
  * Contributors: Chris Thrasher, Tyler Weaver

 -- Tyler Weaver <maybe@tylerjw.dev>  Wed, 22 Mar 2023 16:00:00 -0000

ros-humble-rsl (0.2.1-1bookworm) bookworm; urgency=high

  * Use constructors over factory functions when possible
  * Implement rsl::rng with std::optional
  * Fix bug when trying to seed rng from first call
  * Make rsl::rng() tests more strenuous
    Seeding on the first call tests a code path that hadn't yet been
    tested but is a valid use of the API.
  * Change version of range-v3 to allow building on Ubuntu Focal (#73 <https://github.com/PickNikRobotics/RSL/issues/73>)
  * Add missing header
    Fixes a build issue when using GCC 12
  * Make it easy for users to override
  * Update Catch2
  * Add tests for rsl::to_parameter_result_msg
  * Contributors: Chris Thrasher, Tony Najjar, Tyler Weaver

 -- Tyler Weaver <maybe@tylerjw.dev>  Mon, 28 Nov 2022 16:00:00 -0000

ros-humble-rsl (0.2.0-1bookworm) bookworm; urgency=high

  * New features
    * rclcpp::Parameter validator functions
    * Algorithms from parameter_traits
    * rsl::StaticVector and rsl::StaticString
  * Doxygen site: https://picknikrobotics.github.io/RSL/files.html
    * Link to the docs from the README
    * Use doxygen-awesome documentation style
    * Deploy documentation website from CI
    * Add Doxygen comments for rsl::Overload
    * Add Doxygen comments for TRY
  * Cleanups
    * Prevent unnecessary string copy
    * Ensure global constants do not violate the ODR
    * Hide rsl::NoDiscard implementation details
    * Use more [[nodiscard]]
    * Fix to_vector for vector<bool>
    * Ensure static container iterators are used
    * Default to building a shared library
    * Use generator-agnostic CMake commands
    * Remove C compiler settings
    * Don't require compiler extensions
    * Use more expressive path variable
    * Add clang-tidy integration and fix errors
    * Address clang-tidy findings
    * Update FindCatch2 module
    * Update Catch2
  * Contributors: Chris Thrasher, Tyler Weaver

 -- Tyler Weaver <maybe@tylerjw.dev>  Mon, 14 Nov 2022 16:00:00 -0000

ros-humble-rsl (0.1.1-1bookworm) bookworm; urgency=high

  * Fix CMake configuration warnings
  * Contributors: Chris Thrasher

 -- Tyler Weaver <maybe@tylerjw.dev>  Mon, 03 Oct 2022 16:00:00 -0000

ros-humble-rsl (0.1.0-1bookworm) bookworm; urgency=high

  * monad.hpp - Functions and operators for monadic expressions
  * no_discard.hpp - [[nodiscard]] for lambdas
  * overload.hpp - Class template for easily visiting variants
  * queue.hpp - Thread-safe queue
  * random.hpp - Modern C++ randomness made easy
  * try.hpp - Macro to emulatate absl::CONFIRM or operator? from Rust
  * Contributors: Chris Thrasher, Tyler Weaver

 -- Tyler Weaver <maybe@tylerjw.dev>  Mon, 03 Oct 2022 16:00:00 -0000

=== debian/control ===
Source: ros-humble-rsl
Section: misc
Priority: optional
Maintainer: Tyler Weaver <maybe@tylerjw.dev>
Build-Depends: debhelper (>= 9.0.0), clang-tidy <!nocheck>, doxygen, git <!nocheck>, libeigen3-dev, libfmt-dev, librange-v3-dev <!nocheck>, ros-humble-rclcpp, ros-humble-tcb-span, ros-humble-tl-expected, ros-humble-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-humble-rsl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libeigen3-dev, libfmt-dev, ros-humble-rclcpp, ros-humble-tcb-span, ros-humble-tl-expected, ros-humble-ros-workspace
Description: ROS Support Library

=== debian/rules ===
--- 
+++ 
@@ -18,7 +18,7 @@
 # 	https://github.com/ros-infrastructure/bloom/issues/327
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
 ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
-	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
+	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
 endif
 
 DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
@@ -28,40 +28,40 @@
 
 override_dh_auto_configure:
 	# In case we're installing to a non-standard location, look for a setup.sh
-	# in the install tree and source it.  It will set things like
-	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
+	# in the install tree that was dropped by catkin, and source it.  It will
+	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
 	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
 	dh_auto_configure -- \
+		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
 		-DCMAKE_INSTALL_PREFIX="/opt/ros/humble" \
-		-DAMENT_PREFIX_PATH="/opt/ros/humble" \
 		-DCMAKE_PREFIX_PATH="/opt/ros/humble" \
 		$(BUILD_TESTING_ARG)
 
 override_dh_auto_build:
 	# In case we're installing to a non-standard location, look for a setup.sh
-	# in the install tree and source it.  It will set things like
-	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
+	# in the install tree that was dropped by catkin, and source it.  It will
+	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
 	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
 	dh_auto_build
 
 override_dh_auto_test:
 	# In case we're installing to a non-standard location, look for a setup.sh
-	# in the install tree and source it.  It will set things like
-	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
+	# in the install tree that was dropped by catkin, and source it.  It will
+	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
 	echo -- Running tests. Even if one of them fails the build is not canceled.
 	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
 	dh_auto_test || true
 
 override_dh_shlibdeps:
 	# In case we're installing to a non-standard location, look for a setup.sh
-	# in the install tree and source it.  It will set things like
-	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
+	# in the install tree that was dropped by catkin, and source it.  It will
+	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
 	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
 	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-rsl//opt/ros/humble/lib/
 
 override_dh_auto_install:
 	# In case we're installing to a non-standard location, look for a setup.sh
-	# in the install tree and source it.  It will set things like
-	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
+	# in the install tree that was dropped by catkin, and source it.  It will
+	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
 	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
 	dh_auto_install
